<?php
echo '<h1>Server Parameters CHECKER</h1>';

define("DB_HOST", "localhost");
define("DB_USER", "DBUSER");
define("DB_PASSWORD", "PASS");
define("DB_NAME", "DBNAME");

define("AFF_API_USER", "FILL");
define("AFF_API_TOKEN", "FILL");

tmrmsShopCheck();

function tmrmsShopCheck() {
    echo '<div class="checker-table">';
    $err = 0;
    $ch = CheckOS();
    if ($ch[1] != 'ok') {
        $err++;
    }
    else{
    $ch[1] = '<span style="color:green">&#10004;' . $ch[1] . '</span>';
    }
    echo '<div><span>Check OS type:</span><span class="data-bold">'.$ch[0].'..................'.$ch[1].'</span></div>';
    $php = CheckPHP();
    if ($php[1] != 'ok') {
        $err++;
    }
    else{
    $php[1] = '<span style="color:green">&#10004;' . $php[1] . '</span>';
    }
    echo '<div><span>Check PHP version:</span><span class="data-bold">'.$php[0].'..................'.$php[1].'</span></div>';
    $ap = CheckApache();
    if ($ap[1] != 'ok') {
        $err++;
    }
    else{
    $ap[1] = '<span style="color:green">&#10004;' . $ap[1] . '</span>';
    }
    echo '<div><span>Check Apache version:</span><span class="data-bold">'.$ap[0].'..................'.$ap[1].'</span></div>';
    $sq = CheckMySQL();
    if ($sq[1] != 'ok') {
        $err++;
    }
    else{
    $sq[1] = '<span style="color:green">&#10004;' . $sq[1] . '</span>';
    }
    echo '<div><span>Check MySQL version:</span><span class="data-bold">'.$sq[0].'..................'.$sq[1].'</span></div>';
    $fo = CheckFsockOpen();
    if ($fo == false) {
        $err++;
    }else{
        $fo = '<span style="color:green">&#10004; ok </span>';
    }
    echo '<div><span>Check fsockopen..................'.$fo.'</span></div>';

    $ce = CheckExec();
    if ($ce != 'ok') {
        $err++;
    }
    else{
    $ce = '<span style="color:green">&#10004;' . $ce . '</span>';
    }
    echo '<div><span>Check exec()..................'.$ce.'</span></div>';

    $se = CheckShellExec();
    if ($se != 'ok') {
        $err++;
    }
    else{
    $se = '<span style="color:green">&#10004;' . $se . '</span>';
    }
    echo '<div><span>Check shell exec()..................'.$se.'</span></div>';
    $is = CheckIniSet();
    if ($is != 'ok') {
        $err++;
    }
    else{
    $is = '<span style="color:green">&#10004;' . $is . '</span>';
    }
    echo '<div><span>Check ini_set()..................'.$is.'</span></div>';
    $me = CheckMaxExecTime();
    if ($me[1] != 'ok') {
        $err++;
    }
    else{
    $me[1] = '<span style="color:green">&#10004;' . $me[1] . '</span>';
    }
    echo '<div><span>Check max_execution_time(60): <strong>'. $me[0].'</strong>..................'.$me[1].'</span></div>';
    $mi = CheckMaxInputTime();
    if ($mi[1] != 'ok') {
        $err++;
    }
    else{
    $mi[1] = '<span style="color:green">&#10004;' . $mi[1] . '</span>';
    }
    echo '<div><span>Check max_input_time(60): <strong>'. $mi[0].'</strong>..................'.$mi[1].'</span></div>';
    $ml = CheckMemoryLim();
    if ($ml[1] != 'ok') {
        $err++;
    }
    else{
    $ml[1] = '<span style="color:green">&#10004;' . $ml[1] . '</span>';
    }
    echo '<div><span>Check memory_limit(256MB): <strong>'.$ml[0].'</strong>..................'.$ml[1].'</span></div>';


    $cpm = CheckPostMax();
    if ($cpm[1] != 'ok') {
        $err++;
    }
    else{
    $cpm[1] = '<span style="color:green">&#10004;' . $cpm[1] . '</span>';
    }
    echo '<div><span>Check post_max_size(64MB): <strong>'.$cpm[0].'</strong>..................'.$cpm[1].'</span></div>';

    $cfu = CheckFileUploads();
    if ($cfu[1] != 'ok') {
        $err++;
    }
    else{
    $cfu[1] = '<span style="color:green">&#10004;' . $cfu[1] . '</span>';
    }
    echo '<div><span>Check max_file_uploads(128): <strong>'.$cfu[0].'</strong>..................'.$cfu[1].'</span></div>';

    $umf = CheckFileSize();
    if ($umf[1] != 'ok') {
        $err++;
    }
    else{
    $umf[1] = '<span style="color:green">&#10004;' . $umf[1] . '</span>';
    }
    echo '<div><span>Check upload_max_filesize(128MB): <strong>'.$umf[0].'</strong>..................'.$umf[1].'</span></div>';

    $uo = CheckURLfOpen();
    if ($uo != 'ok') {
        $err++;
    }
    else{
    $uo = '<span style="color:green">&#10004;' . $uo . '</span>';
    }
    echo '<div><span>Check allow_url_fopen()..................'.$uo.'</span></div>';

    $csm = CheckSafeMode();
    if ($csm != 'ok') {
        $err++;
    }
    else{
    $csm = '<span style="color:green">&#10004;' . $csm . '</span>';
    }
    echo '<div><span>Check sql.safe.mode()..................'.$csm.'</span></div>';

    $cap = CheckAllowPersistant();
    if ($cap != 'ok') {
        $err++;
    }
    else{
    $cap = '<span style="color:green">&#10004;' . $csm . '</span>';
    }
    echo '<div><span>Check mysql.allow.persistant()..................'.$csm.'</span></div>';

    $map = CheckMaxPersistent();
    if ($map != 'ok') {
        $err++;
    }
    else{
    $map = '<span style="color:green">&#10004;' . $map . '</span>';
    }
    echo '<div><span>Check mysql.max.persistant()..................'.$map.'</span></div>';

    $it = CheckInteractiveTimeout();
    if ($it[1] != 'ok') {
        $err++;
    }
    else{
    $it[1] = '<span style="color:green">&#10004;' . $it[1] . '</span>';
    }
    echo '<div><span>Check interactive_timeout(300): <strong>'.$it[0].'</strong>..................'.$it[1].'</span></div>';
    $wt = CheckWaitTimeout();
    if ($wt[1] != 'ok') {
        $err++;
    }
    else{
    $wt[1] = '<span style="color:green">&#10004;' . $wt[1] . '</span>';
    }
    echo '<div><span>Check wait_timeout(300): <strong>'.$wt[0].'</strong>..................'.$wt[1].'</span></div>';

    $cmp = CheckMaxPacket();
    if ($cmp[1] != 'ok') {
        $err++;
    }
    else{
    $cmp[1] = '<span style="color:green">&#10004;' . $cmp[1] . '</span>';
    }
    echo '<div><span>Check max_allowed_packet(128000000): <strong>'.$cmp[0].'</strong>..................'.$cmp[1].'</span></div>';

    $cg = CheckGrants();
    if ($cg[0] != 'ok') {
        $err++;
    }
    else{
    $cg[0] = '<span style="color:green">&#10004;' . $cg[0] . '</span>';
    }
    echo '<div><span>Check grants: <strong>'.$cg[1].'</strong>..................'.$cg[0].'</span></div>';
    $dataFS = CheckFreeSpace();
    if ($dataFS[1] != 'ok') {
        $err++;
    }
    else{
    $dataFS[1] = '<span style="color:green">&#10004;' . $dataFS[1] . '</span>';
    }
    echo '<div><span>Check free space(1GB+): <strong>'.$dataFS[0].'</strong>..................'.$dataFS[1].'</span></div>';
    $mr = CheckModRewrite();
    if ($mr != 'ok') {
        $err++;
    }
    else{
    $mr = '<span style="color:green">&#10004;' . $mr . '</span>';
    }
    echo '<div><span>Check mod_rewrite module..................'.$mr.'</span></div>';
    echo '<div><span>Check json module..................' . $mr . '</span></div>';
    $cc = CheckCurl();
    if ($cc != 'ok') {
        $err++;
    }
    else{
    $cc = '<span style="color:green">&#10004;' . $cc . '</span>';
    }
    echo '<div><span>Check curl extension..................'.$cc.'</span></div>';
    $cs = CheckSoap();
    if ($cs != 'ok') {
        $err++;
    }
    else{
    $cs = '<span style="color:green">&#10004;' . $cs . '</span>';
    }
    echo '<div><span>Check soap extension..................'.$cs.'</span></div>';
    $ms = CheckMySqli();
    if ($ms != 'ok') {
        $err++;
    }
    else{
    $ms = '<span style="color:green">&#10004;' . $ms . '</span>';
    }
    echo '<div><span>Check mysqli extension..................'.$ms.'</span></div>';
    $dataGD = CheckGD();
    if ($dataGD[1] != 'ok') {
        $err++;
    }
    else{
    $dataGD[1] = '<span style="color:green">&#10004;' . $dataGD[1] . '</span>';
    }
    echo '<div><span>Check GD. Version: <strong>'.$dataGD[0].'</strong>..................'.$dataGD[1].'</span></div>';
    $class = '';


    //$ad = CheckAffData();
    //if ($ad != 'ok') {
      //  $err++;
        //$class = 'error';
    //}
    //else{
    //$ad = '<span style="color:green">&#10004;' . $ad . '</span>';
    //}
    //echo '<div><span>Check affiliate data..................'.$ad.'</span></div><p></p>';


   if ($err == 0) {
        echo '<div style="color:green"><strong><br>Everything is great. You can continue.</strong></div>';
    } else {
        echo '<div style="color:red"><strong>Fix issue(s) first and check again please!</strong></div>';
    }
}

//FUNCTIONS
function CheckOS(){
    $result = strtoupper(PHP_OS);
    if($result == 'LINUX'){
        $msg = 'ok';
    }else{
        $msg = '<span style="color:red">Linux system not detected</span>';
    }
    $resp[0] = $result;
    $resp[1] = $msg;
    return $resp;
}
function CheckPHP(){
    $result = substr(phpversion(), 0, 3);
    if($result < '7.4' && $result > '5.5'){
        $msg = 'ok';
    }
    else{
        $msg = '<span style="color:red">PHP version should be higher than 5.6 but not bigger than 7.3</span>';
    }
    $resp[0] = $result;
    $resp[1] = $msg;
    return $resp;
}
function CheckApache(){
    if( function_exists('apache_get_version') ){
        $result = apache_get_version();
        if($result >= '2.4.7'){
            $msg = 'ok';
        }else{
            $msg = '<span style="color:red">Apache version should be higher.(2.4.7)</span>';
        }
    } else {
        if( !isset( $_SERVER['SERVER_SOFTWARE'] ) || strlen( $_SERVER['SERVER_SOFTWARE'] ) == 0 ){
            $msg = '<span style="color:red">You are using not apache server</span>';
        } else {
            $result = $_SERVER['SERVER_SOFTWARE'];
            $msg = 'ok';
        }
    }

    $resp[0] = $result;
    $resp[1] = $msg;
    return $resp;
}
function CheckMySQL(){
    //$result = mysqli_get_server_info();
    $res = exec('mysql -V');
    if($res){
       $ver = preg_match('@[0-9]+\.[0-9]+\.[0-9]+@', $res, $version);
    }
    if($version[0] >= 5.0){
        $msg = 'ok';
    }else{
        $msg = '<span style="color:red">MySQL version should be higher.(5.0)</span>';
    }
    $resp[0] = $version[0];
    $resp[1] = $msg;
    return $resp;
}
function CheckFsockOpen(){
    $fp = fsockopen("www.google.com", 80, $errno, $errstr, 30);
    fclose($fp);
    return $fp;
}

function CheckExec(){
    //$res = exec('which php');
    if(exec('echo EXEC') == 'EXEC'){
        $resp = 'ok';
    }else{
        $resp = '<span style="color:red">disabled!</span>';
    }
    return $resp;
}
function CheckShellExec(){
    $result = shell_exec('ls -la');
    if ($result){
        $resp = 'ok';
    }else{
        $resp = '<span style="color:red">disabled!</sapn>';
    }
    return $resp;
}
function CheckIniSet(){
    $oldValue = ini_get('display_errors');
    $result = 'ok';
    if (ini_set('display_errors', '0') === false) {
        $result = '<span style="color:red">ini_set editing is forbidden</span>';
    }
    if (ini_set('display_errors', $oldValue) === false) {
        $result = '<span style="color:red">ini_set editing is forbidden</span>';
    }
    return $result;
}
function CheckMaxExecTime(){
    $res = ini_get('max_execution_time');
    if($res >= 60){
        $msg ='ok';
    }else{
        $msg = '<span style="color:red">increase the run time.(up to 60)</span>';
    }
    $resp[0] = $res;
    $resp[1] = $msg;
    return $resp;
}
function CheckMaxInputTime(){
    $res = ini_get('max_input_time');
    if($res >= 60){
        $msg ='ok';
    }else{
        $msg = '<span style="color:red">increase the input time.(up to 60)</span>';
    }
    $resp[0] = $res;
    $resp[1] = $msg;
    return $resp;
}
function CheckMemoryLim(){
    $res = ini_get('memory_limit');
    if($res >= 256){
        $msg ='ok';
    }else{
        $msg = '<span style="color:red">increase memory limit</span>';
    }
    $resp[0] = $res;
    $resp[1] = $msg;
    return $resp;
}

function CheckPostMax(){
    $res = ini_get('post_max_size');
    if($res >= 64){
        $msg ='ok';
    }else{
        $msg = '<span style="color:red">increase Post Max Size</span>';
    }
    $resp[0] = $res;
    $resp[1] = $msg;
    return $resp;
}

function CheckFileSize(){
    $res = ini_get('upload_max_filesize');
    if($res >= 128){
        $msg ='ok';
    }else{
        $msg = '<span style="color:red">increase Upload Max Filesize</span>';
    }
    $resp[0] = $res;
    $resp[1] = $msg;
    return $resp;
}

function CheckFileUploads(){
    $res = ini_get('max_file_uploads');
    if($res >= 128){
        $msg ='ok';
    }else{
        $msg = '<span style="color:red">increase Max File Uploads</span>';
    }
    $resp[0] = $res;
    $resp[1] = $msg;
    return $resp;
}

function CheckURLfOpen(){
    $res = ini_get('allow_url_fopen');
    $res >= 1 ? $res ='ok' : $res = '<span style="color:red">false</span>';
    return $res;
}
function CheckSafeMode(){
    $res = ini_get('sql.safe_mode');
    $res < 1 ? $res ='ok' : $res = '<span style="color:red">please turn off SQL safe mode</span>';
    return $res;
}

function CheckAllowPersistant(){
    $ressql = ini_get('mysql.allow_persistent');
    $ressqli = ini_get('mysqli.allow_persistent');
    $res = $ressql + $ressqli;
    $res >= 1 ? $res ='ok' : $res = '<span style="color:red">please turn on mysql.allow_persistent</span>';
    return $res;
}
function CheckMaxPersistent(){
    $resmql = ini_get('mysql.max_persistent');
    $resmqli = ini_get('mysqli.max_persistent');
    $res = $resmql + $resmqli;
    $res <= 0 ? $res ='ok' : $res = '<span style="color:red">please turn on mysql.allow_persistent</span>';
    return $res;
}

function CheckInteractiveTimeout(){
    $sql = mysqli_connect(DB_HOST,DB_USER,DB_PASSWORD,DB_NAME);
    $query = "SHOW VARIABLES WHERE Variable_name='interactive_timeout';";
    $result = $sql->query($query) or die($query.'<br />'.$sql->error);
    $row = $result->fetch_object();

    if($row->Value >= 300){
        $msg ='ok';
    }else{
        $msg = '<span style="color:red">increase interactive timeout</span>';
    }
    $resp[0] = $row->Value;
    $resp[1] = $msg;
    return $resp;
}
function CheckWaitTimeout(){
    $sql = mysqli_connect(DB_HOST,DB_USER,DB_PASSWORD,DB_NAME);
    $query = "SHOW VARIABLES WHERE Variable_name='wait_timeout';";
    $result = $sql->query($query) or die($query.'<br />'.$sql->error);
    $row = $result->fetch_object();

    if($row->Value >= 300){
        $msg ='ok';
    }else{
        $msg = '<span style="color:red">increase wait timeout</span>';
    }
    $resp[0] = $row->Value;
    $resp[1] = $msg;
    return $resp;
}

function CheckMaxPacket(){
    $sql = mysqli_connect(DB_HOST,DB_USER,DB_PASSWORD,DB_NAME);
    $query = "SHOW VARIABLES WHERE Variable_name='max_allowed_packet';";
    $result = $sql->query($query) or die($query.'<br />'.$sql->error);
    $row = $result->fetch_object();

    if($row->Value >= 128000000){
        $msg ='ok';
    }else{
        $msg = '<span style="color:red">increase SQL Max Allowed Packet</span>';
    }
    $resp[0] = $row->Value;
    $resp[1] = $msg;
    return $resp;
}

function CheckGrants() {
    $alter_ok = true; // false
    $pr = '';

    $sql = mysqli_connect(DB_HOST, DB_USER, DB_PASSWORD, DB_NAME);
    $query = "SHOW GRANTS FOR CURRENT_USER();";
    $result = $sql->query($query);

    if( $result ) {
    $row = $result->fetch_object();
    $privileges = reset($row);
    $matched = preg_match('/grant([\s\w\,]+)on/i', $privileges, $matches);

    if( $matched !== false ) {
        $privileges = $matches[1];
        $privileges = trim($privileges);
        $pr = $privileges;
        $privileges_array = preg_split('/,\s+/i', $privileges);

        if( is_array($privileges_array) ) {
            $required = 'ALTER';
            $all = 'ALL PRIVILEGES';
            if( in_array($required, $privileges_array) || in_array($all, $privileges_array) ) {
                $alter_ok = true;
            }
        } // if $privileges_array is array
    } // if matched

    } // if $result

    if( $alter_ok ) {
    $res[0] = 'ok';
    } else {
    $res[0] = '<span style="color:red">you should create user with ALTER privileges</span>';
    }
    $res[1] = $pr;

    return $res;
}
function CheckFreeSpace(){
    $bytes = disk_free_space(".");
    $si_prefix = array( 'B', 'KB', 'MB', 'GB', 'TB', 'EB', 'ZB', 'YB' );
    $base = 1024;
    $class = min((int)log($bytes , $base) , count($si_prefix) - 1);
    $res = sprintf('%1.2f' , $bytes / pow($base,$class)) . ' ' . $si_prefix[$class];
    $bytes >= 1073741824 ? $msg = 'ok' : $msg = '<span style="color:red">too few available space on the disk</span>';
    $resp[0] = $res;
    $resp[1] = $msg;
    return $resp;
}
function CheckModRewrite(){
    if( function_exists('apache_get_modules') && in_array('mod_rewrite',apache_get_modules()) ){
    $mod_rewrite = TRUE;
    }elseif( isset($_SERVER['IIS_UrlRewriteModule']) ){
    $mod_rewrite = TRUE;
    }else{
    $mod_rewrite = FALSE;
    }
    $mod_rewrite = true ? $msg = 'ok' : $msg = '<span style="color:red">mod_revrite is not available on this server</span>';
    return $msg;
}
function CheckCurl(){
    $res = function_exists('curl_version');
    $res = true ? $msg = 'ok' : $msg = '<span style="color:red">curl extension is disabled</span>';
    return $msg;
}
function CheckSoap(){
    if(extension_loaded('soap')){
        $msg = 'ok';
    }else{
        $msg = '<span style="color:red">soap extension is disabled</span>';
    }
    return $msg;
}
function CheckMySqli(){
    $res = function_exists('mysqli_connect');
    $res = true ? $msg = 'ok' : '<span style="color:red">mysql extension is disabled</span>';
    return $msg;
}
function CheckGD(){
    $res = gd_info();
    if($res){
        $resp[0] = $res['GD Version'];
        $resp[1] = 'ok';
    }else{
        $resp[0] = '-';
        $resp[1] = '<span style="color:red">GD not supported by your server</span>';
    }
    return $resp;
}
function CheckAffData(){
        $url = 'http://api2.templatemonster.com:80/v2/templates.count.json?user='.AFF_API_USER.'&token='.AFF_API_TOKEN.'';
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_URL, $url);
        $content = json_decode(curl_exec($ch));
        if($content->error_code == 0){
            $msg = 'ok';
        }else{
            $msg = $content->error_code .' '. $content->error_message;
        }
    return $msg;
}
